CREATE OR REPLACE PROCEDURE GERA_AJUSTE_INVCEGO(
   P_CDFILIAL     IN INVENTESTCEGO.CDFILIAL%TYPE,
   P_DTCONTAGEM   IN INVENTESTCEGO.DTCONTAGEM%TYPE,
   P_CDALMOXARIFE IN INVENTESTCEGO.CDALMOXARIFE%TYPE,
   P_CDLOCALESTOQ IN INVENTESTCEGO.CDLOCALESTOQ%TYPE,
   P_CDFILILANC   IN INVENTESTCEGO.CDFILIAL%TYPE,
   P_NRLANCESTQ   IN LANCTOESTOQ.NRLANCESTQ%TYPE,
   P_NRLANCRET    IN LANCTOESTOQ.NRLANCESTQ%TYPE,
   P_NRRETIRADA   IN LANCTOESTOQ.NRLANCESTQ%TYPE,
   P_NRCARDAPIO   IN LANCTOESTOQ.NRLANCESTQ%TYPE,
   P_CDOPERADOR   IN INVENTESTCEGO.CDOPERADOR%TYPE,
   P_GERARETI     IN INVENTESTCEGO.IDINVGERAAJUSTE%TYPE)/* PARAMETRO PARA SABER SE J EXISTE RETIRADA PARA O SERVIO NA DATA*/
AS

BEGIN

   DECLARE

   V_VRCUSTO      VARCHAR2(02);
   V_IDORDEMCLC   VARCHAR2(1);
   V_GRAVARET     VARCHAR2(1);
   V_NRCARDAPIO   VARCHAR2(10);
   V_PRIMEIRA     NUMBER;
   V_NRSEQUITEM   NUMBER;
   V_NRSEQITRET   NUMBER;
   V_COUNT        NUMBER;
   V_QTESTOQDIA   NUMBER;
   V_DTINICIO     DATE;
   V_DTFIM        DATE;


   BEGIN
      V_PRIMEIRA   := 0;
      V_NRSEQUITEM := 0;
      V_IDORDEMCLC := ' ';
      V_COUNT      := 0;
      V_NRSEQITRET := 0;

      FOR C_INVENTESTCEGO IN ( SELECT IV.CDFILIAL, DECODE(IDORDAJUINVE, 'U', IV.DTCONTAGEM, IV.DTCONTAGEM + 1) AS DTGERAAJUSTE,
                                      IV.DTCONTAGEM, NVL(IV.CDALMOXARIFE,' ') CDALMOXARIFE,
                                      NVL(IV.CDLOCALESTOQ,' ') CDLOCALESTOQ, IDSITESTCEGO, IDSITUACEITEINV,
                                      DTAPROVINVESTCE, DTGERACAOINVEST, IDINVGERAAJUSTE,
                                      IV.CDOPERADOR CDOPERINVENT, IT.CDPRODUTO, NVL(IT.NRLOTEESTQ,' ') NRLOTEESTQ,
                                      NVL(IT.NRSUBLOTE,' ') NRSUBLOTE, QTINVENTESTCEGO,
                                      IT.CDOPERADOR CDOPERITEM,
                                      TO_NUMBER(NVL(CDTIPCUSTEST,'03')) CDTIPOCUSTO,
                                      IDINVESTCEGO, IDGERARETAJU, CDSERVBAIESTCEG, CDTPRETBXESTCEG,
                                      CDPRODESTO, PR.VRFATOCONV, IDORDAJUINVE, L.DTVALILOTE,
                                      DECODE(IDORDAJUINVE, 'U', IV.DTCONTAGEM, IV.DTCONTAGEM + 1) DTRETI,
                                      NVL(CUSTO_PRODUTO_LCEST(IV.CDFILIAL, CDPRODESTO,
                                           TO_NUMBER(NVL(CDTIPCUSTEST,'03')), IV.DTCONTAGEM, SYSDATE,
                                           IV.CDALMOXARIFE, IV.CDLOCALESTOQ, IT.NRLOTEESTQ,IT.NRSUBLOTE),0) AS VRCUSTOPROD,
                                      DECODE(IDUTILDTPROC, 'S', NVL(DTPROCESSA,SYSDATE), SYSDATE) DTPROCESSA
                                 FROM INVENTESTCEGO IV, ITEMINVENTCEGO IT, PARAMFILIAL P, PRODUTO PR, LOTE L, PARAMGERAL
                                 WHERE IV.CDFILIAL    = P_CDFILILANC
                                  AND IV.CDFILIAL     = IT.CDFILIAL
                                  AND IV.CDALMOXARIFE = P_CDALMOXARIFE
                                  AND IV.CDLOCALESTOQ = P_CDLOCALESTOQ
                                  AND IV.CDALMOXARIFE = IT.CDALMOXARIFE
                                  AND IV.CDLOCALESTOQ = IT.CDLOCALESTOQ
                                  AND IV.DTCONTAGEM   = IT.DTCONTAGEM
                                  AND IV.CDFILIAL     = P.CDFILIAL
                                  AND IT.CDPRODUTO    = PR.CDPRODUTO
                                  AND IV.CDFILIAL     = L.CDFILIAL
                                  AND IT.NRLOTEESTQ   = L.NRLOTEESTQ
                                  AND IT.NRSUBLOTE    = L.NRSUBLOTE
                                  AND PR.CDPRODESTO   = L.CDPRODUTO
                                  AND IV.DTCONTAGEM   = P_DTCONTAGEM
                                  AND IDSITESTCEGO    = 'AP'
                                ORDER BY IV.DTCONTAGEM ) LOOP



            /* inserir na tabela lanctoestoq apenas uma vez */

            SELECT COUNT(*)
              INTO V_COUNT
              FROM LANCTOESTOQ
             WHERE CDFILIAL   = P_CDFILIAL
               AND NRLANCESTQ = P_NRLANCESTQ
               AND DTLANCESTQ = C_INVENTESTCEGO.DTGERAAJUSTE;

            IF V_COUNT = 0 THEN

               INSERT INTO LANCTOESTOQ
                  (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ,
                  DSLANCESTQ, IDALTCUSMED, CDOPERADOR, CDFILIMOVI)
               VALUES
                 (P_CDFILIAL, P_NRLANCESTQ, '1',
                 C_INVENTESTCEGO.DTGERAAJUSTE, 'Lanamento realizado pelo ajuste do inventrio cego',
                 'N', P_CDOPERADOR,P_CDFILILANC);
            END IF;

            IF (NVL(C_INVENTESTCEGO.IDORDAJUINVE,'P') = 'P') THEN

               V_IDORDEMCLC := '0';
            ELSE
               V_IDORDEMCLC := 'U';
            END IF;


            INSERT INTO ITLANCTOEST
               (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, VRUNILANCTO,
               VRTOTLANCTO, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC, VRLANCTOEST, QTTOTLANCTO,
               CDFILIMOVI, CDPRODMOVI, VRLANCTOBRUT, IDEVOLESTOQ, CDALMOXARIFE,
               CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDOPERADOR)
            VALUES
               (P_CDFILIAL, P_NRLANCESTQ, LPAD(TO_CHAR(V_NRSEQUITEM), 4,'0'),
               C_INVENTESTCEGO.CDPRODUTO, C_INVENTESTCEGO.QTINVENTESTCEGO * C_INVENTESTCEGO.VRFATOCONV,
               C_INVENTESTCEGO.VRCUSTOPROD * C_INVENTESTCEGO.VRFATOCONV,
               C_INVENTESTCEGO.VRCUSTOPROD * C_INVENTESTCEGO.VRFATOCONV * C_INVENTESTCEGO.QTINVENTESTCEGO,
               '1', C_INVENTESTCEGO.DTGERAAJUSTE , V_IDORDEMCLC, C_INVENTESTCEGO.VRCUSTOPROD,
               C_INVENTESTCEGO.QTINVENTESTCEGO,
               P_CDFILILANC, C_INVENTESTCEGO.CDPRODESTO, C_INVENTESTCEGO.VRCUSTOPROD, 'S',
               C_INVENTESTCEGO.CDALMOXARIFE,C_INVENTESTCEGO.CDLOCALESTOQ,
               C_INVENTESTCEGO.NRLOTEESTQ,C_INVENTESTCEGO.NRSUBLOTE, P_CDOPERADOR);

            /***** POSIO DO DIA DA GERAO DO AJUSTE *****/

            SELECT MAX(A.QTESTOQDIA)
              INTO V_QTESTOQDIA
              FROM POSESTDIA A
             WHERE (A.CDFILIAL     = P_CDFILILANC)
               AND (A.CDALMOXARIFE = C_INVENTESTCEGO.CDALMOXARIFE)
               AND (A.CDLOCALESTOQ = C_INVENTESTCEGO.CDLOCALESTOQ)
               AND (A.NRLOTEESTQ   = C_INVENTESTCEGO.NRLOTEESTQ)
               AND (A.NRSUBLOTE    = C_INVENTESTCEGO.NRSUBLOTE)
               AND (A.CDPRODUTO    = C_INVENTESTCEGO.CDPRODESTO)
               AND (A.DTPOSIESTQ   = DTPOSICAO_POSESTDIA(P_CDFILILANC, C_INVENTESTCEGO.CDPRODESTO, C_INVENTESTCEGO.CDALMOXARIFE, C_INVENTESTCEGO.CDLOCALESTOQ,
                                                         C_INVENTESTCEGO.NRLOTEESTQ, C_INVENTESTCEGO.NRSUBLOTE, C_INVENTESTCEGO.DTGERAAJUSTE + 1));

            IF (C_INVENTESTCEGO.IDGERARETAJU = 'S') AND (P_GERARETI = 'S') THEN
               IF C_INVENTESTCEGO.CDSERVBAIESTCEG IS NOT NULL THEN
                  IF C_INVENTESTCEGO.QTINVENTESTCEGO < V_QTESTOQDIA THEN
                     V_GRAVARET := 'S';
                     IF V_PRIMEIRA = 0 THEN

                        SELECT COUNT(*)
                          INTO V_COUNT
                          FROM LANCTOESTOQ
                         WHERE CDFILIAL   = P_CDFILIAL
                           AND NRLANCESTQ = P_NRLANCRET
                           AND DTLANCESTQ = C_INVENTESTCEGO.DTGERAAJUSTE;

                        IF V_COUNT = 0 THEN
                           INSERT INTO LANCTOESTOQ
                            (CDFILIAL,   NRLANCESTQ, IDTPLANCTO,
                             DTLANCESTQ, CDFILIMOVI, CDOPERADOR,
                             IDALTCUSMED, DSLANCESTQ)
                           VALUES
                            (P_CDFILIAL,  P_NRLANCRET, '3',
                             C_INVENTESTCEGO.DTGERAAJUSTE, P_CDFILILANC, P_CDOPERADOR,
                             'N', 'Retirada para Ajuste : '|| P_NRLANCESTQ);
                        END IF;

                        SELECT MAX(NRCARDAPIO)
                          INTO V_NRCARDAPIO
                          FROM CARDADIA
                         WHERE (CDFILIAL   = P_CDFILILANC)
                           AND (CDSERVFILI = C_INVENTESTCEGO.CDSERVBAIESTCEG)
                           AND (DTCARDAPIO = C_INVENTESTCEGO.DTGERAAJUSTE);

                         IF V_NRCARDAPIO IS NULL THEN
                            INSERT INTO CARDADIA
                             (CDFILIAL, NRCARDAPIO, CDSERVFILI, CDOPERADOR, DTCARDAPIO, DTMESCARD)
                            VALUES
                             (P_CDFILILANC, P_NRCARDAPIO, C_INVENTESTCEGO.CDSERVBAIESTCEG,
                              P_CDOPERADOR, C_INVENTESTCEGO.DTGERAAJUSTE,
                              (LAST_DAY(ADD_MONTHS(C_INVENTESTCEGO.DTGERAAJUSTE, -1)) + 1) );

                            INSERT INTO RETIRADA
                             (CDFILIAL, NRRETIRADA, NRCARDAPIO, DTRETIRADA, CDFILANCESTQ, NRLANCESTQ)
                            VALUES
                             (P_CDFILILANC, P_NRRETIRADA, P_NRCARDAPIO, C_INVENTESTCEGO.DTGERAAJUSTE,
                              P_CDFILIAL, P_NRLANCRET);

                         ELSE

                            INSERT INTO RETIRADA
                             (CDFILIAL, NRRETIRADA, NRCARDAPIO, DTRETIRADA, CDFILANCESTQ, NRLANCESTQ)
                            VALUES
                             (P_CDFILILANC, P_NRRETIRADA, V_NRCARDAPIO, C_INVENTESTCEGO.DTGERAAJUSTE,
                              P_CDFILIAL, P_NRLANCRET);
                         END IF;


                         INSERT INTO AJURELACRET
                          (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                         VALUES
                          (P_CDFILIAL, P_NRLANCESTQ, P_CDFILIAL, P_NRLANCRET);

                        V_PRIMEIRA := 1;
                     END IF;
                  ELSE
                    V_GRAVARET := 'N';
                  END IF;
               END IF;

               IF V_GRAVARET = 'S' THEN

                           /*GRAVAR DTLANCMOVI, SENDO QUE - 1 CASO AJUSTE PRIMEIRO DO DIA*/

                  INSERT INTO ITLANCTOEST
                     (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST,  QTTOTLANCTO,
                      CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                      IDTIPOMOVI, IDEVOLESTOQ, IDORDEMCLC, IDALTCMEDMV, CDTIPORETI, VRUNILANCTO,
                      VRTOTLANCTO, DTLANCMOVI )
                  VALUES
                     (P_CDFILIAL, P_NRLANCRET, LPAD(TO_CHAR(V_NRSEQITRET), 4,'0'),C_INVENTESTCEGO.CDPRODUTO,
                      (V_QTESTOQDIA - C_INVENTESTCEGO.QTINVENTESTCEGO) * C_INVENTESTCEGO.VRFATOCONV,
                      (V_QTESTOQDIA - C_INVENTESTCEGO.QTINVENTESTCEGO) * C_INVENTESTCEGO.VRFATOCONV,
                      C_INVENTESTCEGO.CDPRODESTO, P_CDFILILANC, C_INVENTESTCEGO.CDALMOXARIFE,
                      C_INVENTESTCEGO.CDLOCALESTOQ, C_INVENTESTCEGO.NRLOTEESTQ, C_INVENTESTCEGO.NRSUBLOTE,
                      '3', 'S', '9', 'N', C_INVENTESTCEGO.CDTPRETBXESTCEG,
                       C_INVENTESTCEGO.VRCUSTOPROD * C_INVENTESTCEGO.VRFATOCONV,
                       C_INVENTESTCEGO.VRCUSTOPROD * C_INVENTESTCEGO.VRFATOCONV * (V_QTESTOQDIA - C_INVENTESTCEGO.QTINVENTESTCEGO),
                       C_INVENTESTCEGO.DTRETI);

                  SELECT MAX(NRCARDAPIO)
                    INTO V_NRCARDAPIO
                    FROM CARDADIA
                   WHERE (CDFILIAL   = P_CDFILILANC)
                     AND (CDSERVFILI = C_INVENTESTCEGO.CDSERVBAIESTCEG)
                     AND (DTCARDAPIO = C_INVENTESTCEGO.DTGERAAJUSTE);

                  IF V_NRCARDAPIO IS NULL THEN
                     INSERT INTO ITEMRETI
                        (CDFILIAL, NRRETIRADA, NRCARDAPIO, NRSEQUITRETI,
                         CDPRODUTO, QTRETIRADA, CDFIITLANEST, NRLANCESTQ, NRSEQUITEM, CDTIPORETI)
                     VALUES
                        (P_CDFILILANC, P_NRRETIRADA, P_NRCARDAPIO,
                         LPAD(TO_CHAR(V_NRSEQITRET), 4,'0'), C_INVENTESTCEGO.CDPRODUTO,
                         (V_QTESTOQDIA - C_INVENTESTCEGO.QTINVENTESTCEGO) * C_INVENTESTCEGO.VRFATOCONV,
                         P_CDFILIAL, P_NRLANCRET, LPAD(TO_CHAR(V_NRSEQUITEM), 4,'0'),
                         C_INVENTESTCEGO.CDTPRETBXESTCEG);
                  ELSE
                     INSERT INTO ITEMRETI
                        (CDFILIAL, NRRETIRADA, NRCARDAPIO, NRSEQUITRETI,
                         CDPRODUTO, QTRETIRADA, CDFIITLANEST, NRLANCESTQ, NRSEQUITEM, CDTIPORETI)
                     VALUES
                        (P_CDFILILANC, P_NRRETIRADA, V_NRCARDAPIO,
                         LPAD(TO_CHAR(V_NRSEQITRET), 4,'0'), C_INVENTESTCEGO.CDPRODUTO,
                         (V_QTESTOQDIA - C_INVENTESTCEGO.QTINVENTESTCEGO) * C_INVENTESTCEGO.VRFATOCONV,
                         P_CDFILIAL, P_NRLANCRET, LPAD(TO_CHAR(V_NRSEQUITEM), 4,'0'),
                         C_INVENTESTCEGO.CDTPRETBXESTCEG);
                  END IF;

               END IF;

            END IF;

            V_NRSEQUITEM := V_NRSEQUITEM + 1;
            V_NRSEQITRET := V_NRSEQITRET + 1;
            IF C_INVENTESTCEGO.DTRETI <= C_INVENTESTCEGO.DTPROCESSA THEN
               V_DTINICIO := C_INVENTESTCEGO.DTRETI;
               V_DTFIM    := C_INVENTESTCEGO.DTPROCESSA;
            ELSE
               V_DTINICIO := C_INVENTESTCEGO.DTPROCESSA;
               V_DTFIM    := C_INVENTESTCEGO.DTRETI;
            END IF;

            UPDATE ITEMINVENTCEGO
               SET IDAJUSTEGERAIT  = 'S'
             WHERE CDFILIAL        = P_CDFILILANC
               AND CDALMOXARIFE    = C_INVENTESTCEGO.CDALMOXARIFE
               AND CDLOCALESTOQ    = C_INVENTESTCEGO.CDLOCALESTOQ
               AND DTCONTAGEM      = P_DTCONTAGEM
               AND CDPRODUTO       = C_INVENTESTCEGO.CDPRODUTO
               AND NRLOTEESTQ      = C_INVENTESTCEGO.NRLOTEESTQ
               AND NRSUBLOTE       = C_INVENTESTCEGO.NRSUBLOTE;
      END LOOP;

      ATUALIZA_ESTOQUE(P_CDFILILANC, V_DTINICIO, V_DTFIM, P_CDFILIAL, P_NRLANCESTQ);

         /*Atualizar a Itlanctoest para no evoluir estoque para o ajuste */

      FOR C_PRODIRREG IN ( SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                  CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                             FROM MOVILOTE
                            WHERE NRMOVILOTE     = P_CDFILIAL||P_NRLANCESTQ
                              AND CDFILIAL       = P_CDFILILANC ) LOOP
          UPDATE ITLANCTOEST
             SET IDEVOLESTOQ  = 'N'
           WHERE CDFILIAL     = P_CDFILIAL
             AND NRLANCESTQ   = P_NRLANCESTQ
             AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
             AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
             AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
             AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
             AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

          UPDATE ITLANCTOEST
             SET IDEVOLESTOQ  = 'N'
           WHERE CDFILIAL     = P_CDFILIAL
             AND NRLANCESTQ   = P_NRLANCRET
             AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
             AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
             AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
             AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
             AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

      END LOOP;

      ATUALIZA_ESTOQUE(P_CDFILILANC, V_DTINICIO, V_DTFIM, P_CDFILIAL, P_NRLANCESTQ);

      DELETE MOVILOTE
       WHERE NRMOVILOTE = P_CDFILIAL||P_NRLANCESTQ;
   END;
END;
/